;----------------------------------------------------------------------------;
; File Array2Array.asm
; Written by Tran Dinh Hop - Date: 29 June 2004
;
; Assume:
; 	- M1 and M2 are byte-array, 25 elements for each array.  
;	- M1 contains data in range of 'A'..'Z', 'a'..'z', space and M2 is empty 
; This program do:
;	- Travel entitle M1 and elements will be copied to M2 if they are uppercase 
;	- Convert elem of M2 to lowercase, then display the elem   
;	- Display number of elements copied to M2
; Note:
;	- Co the doi thanh DW, Lap bang CX va bang bien dem tu do????
;----------------------------------------------------------------------------;

DOSSEG

.MODEL Small						; Make *.exe file
.STACK 200						; Make a 200-byte stack
.DATA
	; Define array M1 and M2
	M1	DB	'IBLoveBAssemblyBLanguageB'; 25 chars
	M2	DB	25 DUP (?)			; empty M2
	_Message1	DB 'There were $'		; Display a message 
	_Message2 DB 'capital letters copied from M1 to M2$'
	_NewLine 	DB 0Ah, 0Dh,'$'		; LF and RC

.CODE

	THEMAIN PROC					; void main(void)

	XOR	CX,CX					; define a counter=0
	LEA	SI,M1					; points to head of M1 (SI:=M1[0])
	LEA	DI,M2					; points to head of M2 (DI:=M2[0])
	MOV	DH,19h					; Define repated times =25 //(32h=50)

;------------------- travel M1 and copy uppercase to M2 -----------------------
For_Label_1:
	MOV	AL,[SI]					; Current element of M1[i]
	CMP	AL,5Ah					; compare M1[i] and 5Ah (upper/lower)?
	JA	Ignore					; If lowercase then ignore the element
	MOV	[DI],AL					; If uppercase, copied to M2[i]
	INC	CX						; counter:=counter+1
	INC	DI						; next element of M2

Ignore:
	INC	SI						; next element of M1
	DEC	DH						; Decrease repeated times
	JNZ	For_Label_1				; Repeat if rep' times<=25
	JCXZ	Quit						; Quit if M2 is still empty (CX=0) 

;---------- convert elem of M2 to lowercase and display ----------
;
   	MOV  AH,9                		; Output message 1
	LEA  DX,_Message1		  		; 
	INT  21h                 		; 

    	MOV  AH,2                		; Output number of copied elems
	MOV  DX,CX			  		; DX gets the counter in CX
	AND	DL,0Fh					; convert number to char
	INT  21h                 		; 

 	MOV  AH,9                		; Output message 2
	LEA  DX,_Message2		  		; 
	INT  21h                 		; 
	LEA	DX, _NewLine
	INT	21h
;
	LEA	SI,M2					; point to head of M2
	MOV	AH,2						; prepare for display

For_Label_2:						;
	MOV	DL,[SI]					; current element of M2
	AND	DL,0Fh					; convert upper to lower
	INT	21h						; Display M2[i] on screen
	INC	SI						; next element of M2
	LOOP For_Label_2				; Use count variable in CX

Quit:
  	MOV AH,4Ch                       	; Exit to DOS
 	INT 21h

	THEMAIN ENDP
END THEMAIN

